"""
Utilities for the Cognite Wells SDK
This module provides helper methods and different utilities for the Cognite Wells SDK
This module is protected and should not be used by end-users.
"""
from typing import Callable


def extend_class(cls) -> Callable:
    """
    decorator be used for creating extension function on already existing classes

    @param cls: class to be extended
    @return: the extended class
    """
    return lambda f: (setattr(cls, f.__name__, f) or f)  # type: ignore
