"""
    Well service

    Query and ingestion to the well data layer  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from cognite.well_model.model.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from cognite.well_model.model.model.label import Label
    globals()['Label'] = Label


class Asset(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    additional_properties_type = None

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'created_time': (int,),  # noqa: E501
            'last_updated_time': (int,),  # noqa: E501
            'root_id': (int,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'id': (int,),  # noqa: E501
            'parent_id': (int,),  # noqa: E501
            'parent_external_id': (str,),  # noqa: E501
            'external_id': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'data_set_id': (int,),  # noqa: E501
            'metadata': ({str: (str,)},),  # noqa: E501
            'source': (str,),  # noqa: E501
            'labels': ([Label],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'created_time': 'createdTime',  # noqa: E501
        'last_updated_time': 'lastUpdatedTime',  # noqa: E501
        'root_id': 'rootId',  # noqa: E501
        'name': 'name',  # noqa: E501
        'id': 'id',  # noqa: E501
        'parent_id': 'parentId',  # noqa: E501
        'parent_external_id': 'parentExternalId',  # noqa: E501
        'external_id': 'externalId',  # noqa: E501
        'description': 'description',  # noqa: E501
        'data_set_id': 'dataSetId',  # noqa: E501
        'metadata': 'metadata',  # noqa: E501
        'source': 'source',  # noqa: E501
        'labels': 'labels',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, created_time, last_updated_time, root_id, name, id, *args, **kwargs):  # noqa: E501
        """Asset - a model defined in OpenAPI

        Args:
            created_time (int): The number of milliseconds since 00:00:00 Thursday, 1 January 1970, Coordinated Universal Time (UTC), minus leap seconds.
            last_updated_time (int): The number of milliseconds since 00:00:00 Thursday, 1 January 1970, Coordinated Universal Time (UTC), minus leap seconds.
            root_id (int): The ID of the root asset. The root asset is the asset spanning the entire asset hierarchy that this asset belongs to.
            name (str): The name of the asset.
            id (int): id of the corresponding CDF asset

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            parent_id (int): id of the CDF parent. [optional]  # noqa: E501
            parent_external_id (str): The parent node's external ID used to specify the parent-child relationship.. [optional]  # noqa: E501
            external_id (str): The external ID provided by the client. Must be unique for the resource type.. [optional]  # noqa: E501
            description (str): additional description for the data. [optional]  # noqa: E501
            data_set_id (int): The id of the dataset this asset belongs to.. [optional]  # noqa: E501
            metadata ({str: (str,)}): metadata connected to the sequence. [optional]  # noqa: E501
            source (str): [optional]  # noqa: E501
            labels ([Label]): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.created_time = created_time
        self.last_updated_time = last_updated_time
        self.root_id = root_id
        self.name = name
        self.id = id
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
